import 'dart:io';

import 'package:args/args.dart';
import 'package:path/path.dart';

class OptionParser {
  final parser = ArgParser();

  var results;

  String _outPath;
  String _mode;

  String get outPath => _outPath;
  String get mode => _mode;

  bool get isTest => _mode == 'test';
  bool get isDebug => _mode == 'debug';

  String _filePath;

  OptionParser(List<String> args) {
    // parser.addCommand('init');

    parser.addOption('mode', defaultsTo: 'debug');
    parser.addOption('out', defaultsTo: './');
    results = parser.parse(args);

    _outPath = normalize(join(current, results['out']));
    _mode = results['mode'];

    _filePath = normalize(join(current, results.rest[0]));
  }

  void trace() {
    print('mode: $_mode');
    print('out: $_outPath');
    print('filePath: $_filePath');

    final str = Platform.script.toString();
    print(dirname(str));
    print(basename(str));
    print(basenameWithoutExtension(str));
    print(current);
  }
}
