import 'char.dart';

class Character {

  static bool isDecimalDigit(int ch) {
    return Char.num_0 <= ch && ch <= Char.num_9;
  }

  static bool isBinaryDigit(int ch) {
    return ch == Char.num_0 || ch == Char.num_1;
  }

  static bool isOctalDigit(int ch) {
    return Char.num_0 <= ch && ch <= Char.num_7;
  }

  static bool isHexDigit(int ch) {
    return (Char.num_0 <= ch && ch <= Char.num_9) ||
        (Char.A <= ch && ch <= Char.F) ||
        (Char.a <= ch && ch <= Char.f);
  }


  static bool isIdentifierStart(int ch) {
    return ch == Char.Underscore ||
        (Char.A <= ch && ch <= Char.Z) ||
        (Char.a <= ch && ch <= Char.z) ||
        (ch == Char.BackSlash);
  }

  static bool isIdentifierPart(int ch) {
    return ch == Char.Underscore ||
        (Char.A <= ch && ch <= Char.Z) ||
        (Char.a <= ch && ch <= Char.z) ||
        (ch == Char.BackSlash) ||
        (Char.num_0 <= ch && ch <= Char.num_9) ||
        (ch == Char.BackSlash);
  }

  static bool isWhiteSpace(int cp) {
    return cp == Char.Space || cp == Char.Tap;
  }

  static bool isLineTerminator(int cp) {
    return cp == Char.LF || cp == Char.CR;
  }
}
