import 'package:test/test.dart';
import 'package:coders/parser/parser.dart';

void main() {

  test('parser-func-3', () {
    Parser('func test() integer { ++count; }').parse();

    var source = '''
    func test() integer {
      _nickname = _var1 = _var2 = 'aaa';
    }
    ''';
    Parser(source).parse();
  });

  test('parser-func-2', () {
    var source = '''
    func test() integer {
      var _userId varchar(8) = '';
      {
        var _nickname varchar(32) = '';
      }
    }
    ''';
    Parser(source).parse();
  });

  test('parser-func-1', () {
    var source = '''
    func test(in param1 varchar(8), out ret integer) integer {
    }
    ''';

    Parser(source).parse();
  });

  test('parser-type-1', () {
    var source = 'type Identifier varchar(8);';
    Parser(source).parse();
  });

  test('parser-table-1', () {
    var source = '''
    table User {
      userId varchar(8) = '';
      nickname varchar(64) nullable;
      value1 integer = 10 nullable;
      value2 bigint auto;
      value3 double;
    }
    ''';
    Parser(source).parse();
  });

  test('parser-struct-1', () {
    var source = '''
      struct User {
        userId varchar(8);
        name1 varchar(64);
        name2 string;
      }
      ''';
    Parser(source).parse();
  });
}
